![onecode_logo](https://github.com/deeplime-io/onecode/raw/main/docs/assets/onecode.jpg)

![GitHub release](https://img.shields.io/github/v/release/deeplime-io/onecode?sort=semver)
![PyPI - License](https://img.shields.io/pypi/l/onecode)
![PyPI - Python Version](https://img.shields.io/pypi/pyversions/onecode)
![GitHub Workflow Status](https://img.shields.io/github/actions/workflow/status/deeplime-io/onecode/validation.yml?event=push&label=test%20status)
![Windows supported](https://img.shields.io/badge/platform-linux-%23f2c300?logo=linux)
![Linux supported](https://img.shields.io/badge/platform-windows-%230072c9?logo=windows)
[![Maintainability](https://api.codeclimate.com/v1/badges/df236aa4b4ab765ba7db/maintainability)](https://codeclimate.com/github/deeplime-io/onecode/maintainability)
[![Coverage](https://codecov.io/gh/deeplime-io/onecode/graph/badge.svg?token=BF54VNGWM5)](https://codecov.io/gh/deeplime-io/onecode)


---
## Manifesto
Whether we are in the industry, academia, or simply in our everyday-life, we find ourselves encountering 3 categories of profiles no matter what the topic:

- people who love to write code but don’t necessarily have an application for it (a.k.a. the **developers**). Their pain point is usually finding something useful to create as well as a mass of people to actually use it on a regular basis (a.k.a. the developers’ dream).

- people who actually have problems to solve but don’t even know how it’s possible to do something about it computerwise-speaking (a.k.a. the **experts**). Most of the time a simple solution (e.g. an Excel macro) does the trick: they may be mind-blown and very grateful about it for “saving their life” (a.k.a. the developers’ greatest disappointment, as developers would have loved to create a brand-new cloud-based fully automated web-app synchronized with your phone ready to welcome a million users). Their pain point is finding someone who can identify the root cause of the issues and solve it.

- people who started as **experts** and have an affinity for technology (a.k.a. the **tech-savvy/data scientists**). They are genuinely interested in programming and usually start with high-level languages such as Python or JavaScript. Very quickly, they write applications that solve their problems and are super happy to share what they have done and how. They have a foot in both worlds: eventually go further and further down to the dark-side... Their pain point? Writing low-hanging fruit solutions may seem easy at first, but when it comes to create a complete application, deploy it and scale it, things get out-of-hands.

- actually we have a 4th category, people who don’t care at all about it (a.k.a. the vast majority, e.g. my spouse). Developers can’t stop themselves for trying and trying to convince they should be in the **experts** or **tech-savvy/data scientists** category (believe me, I keep trying every time, and 10 years later, it still doesn’t work). Do yourself a favor, just accept it and move on. So, if you’re in that bucket, I guess you can close this page and skip the reading unless you want to know why developers suffer from not being understood.

## [Getting started](https://deeplime-io.github.io/onecode)
